=== test/fasterq-dump/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

default: runtests

TOP ?= $(abspath ../..)

MODULE = test/fasterq-dump

TEST_TOOLS =

include $(TOP)/build/Makefile.env

runtests: result_code_with_and_without_arguments

result_code_with_and_without_arguments:
	@echo "testing if fasterq-dump returns zero if called with help..."
	@$(BINDIR)/fasterq-dump -h > /dev/null
	@echo "OK"	
	@echo "testing if fasterq-dump returns none-zero if called without parameters..."
	@! $(BINDIR)/fasterq-dump > /dev/null
	@echo "OK"

.PHONY: $(TEST_TOOLS) result_code_with_and_without_arguments
