=== debian/changelog ===
sra-sdk (2.11.3+dfsg-1ubuntu1) jammy; urgency=medium

  * Disable LTO, this causes a misbuild that makes fastq-dump segfault.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 05 Apr 2022 15:21:01 +0000

sra-sdk (2.11.3+dfsg-1) unstable; urgency=medium

  [ Andreas Tille ]
  * Fix watchfile to detect new versions on github
  * New upstream version 2.11.2.
  * Standards-Version: 4.6.0 (routine-update)
  * Bump versioned Build-Depends: libngs-sdk-dev (>= 2.11.2)
  * Skip test that test needs a *lot* of memory
  * Link against libzstd.  (Closes: #997280.)

  [ Aaron M. Ucko ]
  * d/p/fix_libngs_linkage.patch (new): Substitute ngs-c++ library for
    absent ngs library.
  * debian/rules: Stop renaming kget (to avoid a file conflict, #851219)
    now that it's retired altogether.
  * d/p/allow_multi_help.patch (new): Tolerate redundant --help
    declarations within tools/driver-tool.
  * d/p/run_unversioned_tools.patch (new): Look for tools by their
    unversioned names, per Debian's simplified installation arrangement.
  * debian/tests: Switch to modern encryption/decryption setup.
    - run-unit-test: Replace protected repository configuration (no longer
      supported as of ncbi-vdb 2.11.0) by --ngc [...].ngc.
    - test-data.tar.gz: Replace dbGaP-0.enc_key by a copy of upstream's
      test/prefetch/data/prj_phs710EA_test.ngc.
  * debian/watch: Look for tags rather than releases, as GitHub currently
    lists none(!) of the latter.
  * New upstream version 2.11.3.

 -- Aaron M. Ucko <ucko@debian.org>  Mon, 25 Oct 2021 18:29:10 -0400
